'' ************************************************************************************
'' *           ____  ____  ____  ____  ________    __    __________                   *
'' *          / __ \/ __ \/ __ \/ __ \/ ____/ /   / /   / ____/ __ \                  *
'' *         / /_/ / /_/ / / / / /_/ / __/ / /   / /   / __/ / /_/ /                  *
'' *        / ____/ _, _/ /_/ / ____/ /___/ /___/ /___/ /___/ _, _/                   *
'' *       /_/   /_/ |_|\____/_/   /_____/_____/_____/_____/_/ |_|                    *
'' *                                                                                  *
'' *      __________  __    ____  ____     ____  ___   _____ __________               *
'' *     / ____/ __ \/ /   / __ \/ __ \   / __ )/   | / ___//  _/ ____/               *
'' *    / /   / / / / /   / / / / /_/ /  / __  / /| | \__ \ / // /                    *
'' *   / /___/ /_/ / /___/ /_/ / _, _/  / /_/ / ___ |___/ // // /___                  *
'' *   \____/\____/_____/\____/_/ |_|  /_____/_/  |_/____/___/\____/                  *
'' *                                                                                  *
'' *                                                                                  *
'' *   PROPELLER COLOR BASIC V2.2l                                                    *
'' *   BY JEFF LEDGER                                                                 *
'' *                                                                                  *
'' * Do not attempt to reuse objects from this package as many have been              *
'' * altered to remove methods which were not used in this project to                 *
'' * conserve all possible memory for the BASIC enviroment.                           *
'' *                                                                                  *
'' * This software would not have been possible without help and contributions from:  *
'' *                                                                                  *
'' *      * Mike Green           - FemtoBASIC                                         *
'' *      * Tomas Rokicki        - FemtoBASIC, & FSWR                                 *
'' *      * Marko Lukat          - Despair & Hope VGA                                 *
'' *      * Jon Williams         - Wii Controller                                     *
'' *      * Johannes Ahlebrand   - TinySynth                                          *
'' *      * Michael Park         - Edit                                               *
'' *      * Andre' LaMothe       - SRAM                                               *
'' *                                                                                  *
'' ************************************************************************************
''
'' Modified by Dane Weston for the Mentor's Friend project in July 2015.
''   -- Eliminated 256-color support, and re-purposed pins 24 and 25 for audio channel.
''   -- Fixed bug in PLOT to prevent plotting on row 75 (off the screen).
''   -- Fixed bug in NEW to clear all 26 program variables (instead of just A through G).
'' HUGE hats off to Jeff Ledger and the other Big Brains above for their work here !!!!
''
obj

   fsrw    : "fsrwfemto"
   key     : "combokeyboard"
   classic : "classic_btnz"
   synth   : "tinysynth"
   font    : "halfrange8x8-1font"
   serial  : "serial"
   sram    : "sram"
     
con

   progsize  = 4096  '' Changing this value is not advised in this verison
                     '' sram.SPIN can be replaced with SRAM_EMPTY.SPIN
                     '' which will allow memory to be increased to 5k (5120). 
   
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000
   _stack    = 100                                                   
                                                              
   keypins   =  26             
   audior    =  24 '10
   audiol    =  25 '11
   wiiscl    =  28 '24
   wiisda    =  29 '25
      
   spido     =  0
   spiclk    =  1              
   spidi     =  2
   spics     =  3

   sramdo    =  0 '8  
   sramclk   =  1 '6
   sramdi    =  2 '7   
   sramcs    =  4 '9

   bgcolor   = 88
   txcolor   = 255
   BASfiles  = 224 '' DIR color of .BAS files
   BINfiles  = 100 '' DIR color of .BIN files
   TXTfiles  = 20 '' DIR color of .TXT files
   
   bspkey    = $c8                                                  
   breakkey  = $cb                                               
   freturn   = 13
   flinefeed = 10
   feof      = -1
      
   maxstack  = 20                                           
   linelen   = 256                                                
   quote     = 34                                    
   casebit   = !32                                              
   userptr   = $7fff                                                           
   versiona  = 50
   versionb  = 50
   versionc  = 108

   WII_ZLEFT     = %01000000_00000000
   WII_B         = %00100000_00000000
   WII_Y         = %00010000_00000000
   WII_A         = %00001000_00000000
   WII_X         = %00000100_00000000
   WII_ZRIGHT    = %00000010_00000000
   WII_LEFT      = %00000001_00000000
   WII_UP        = %00000000_10000000
   WII_RIGHT     = %00000000_01000000 
   WII_DOWN      = %00000000_00100000 
   WII_BLEFT     = %00000000_00010000
   WII_SELECT    = %00000000_00001000
   WII_HOME      = %00000000_00000100
   WII_START     = %00000000_00000010
   WII_BRIGHT    = %00000000_00000001
   
con
                                
   columns  = res_x / 8
   rows     = res_y / font#height
   bcnt     = columns * rows
   rows_raw = (res_y + font#height - 1) / font#height
   bcnt_raw = columns * rows_raw
   dcolour  = (%%0220_0010 & hv_mask | hv_idle) & $ffff * $00010001
   #8, bs, tab, lf, vt, ff, cr, esc = 27
   hv_idle = $01010101 * %00                               
   hv_mask = $fcfcfcfc                               
   res_x   = 400                           
   res_y   = 300                           
   res_m   = 4                                      

var

   long sp, tp, eop, nextlineloc, rv, curlineno, pausetime
   long vars[26], stack[maxstack], control[2]
   long forstep[26], forlimit[26], forloop[26]
   long iocontrol[2]
   word outputs
   byte tline[linelen], tailline[linelen], invars[26], fileopened
   byte joy
   byte midinote, attackrate, decayrate, sustainlevel, pulsewidthinit, pwmrate, fil  
   byte crayon
   byte strbuff[8]
   long rdc[10]
   byte f0[13]
   byte f1[30]
   long Wii_Pad
   
var
                               
   long  link[res_m], cext                                               
   long  plte[bcnt_raw / 2]                                                          
   byte  xx, yy, page                                                                
   word  flag, colour
  
dat

   tok0  byte "IF", 0
   tok1  byte "THEN", 0
   tok2  byte "INPUT", 0                                        
   tok3  byte "PRINT", 0                                   
   tok4  byte "GOTO", 0
   tok5  byte "GOSUB", 0
   tok6  byte "RETURN", 0
   tok7  byte "REM", 0
   tok8  byte "NEW", 0
   tok9  byte "LIST", 0
   tok10 byte "RUN", 0
   tok11 byte "RND", 0
   tok12 byte "OPEN", 0                             
   tok13 byte "READ", 0                          
   tok14 byte "WRITE", 0                                   
   tok15 byte "CLOSE", 0           
   tok16 byte "DELETE", 0                      
   tok17 byte "ATTACK", 0                                       
   tok18 byte "DIR", 0           
   tok19 byte "SAVE", 0                          
   tok20 byte "LOAD", 0                          
   tok21 byte "NOT" ,0                     
   tok22 byte "AND" ,0                               
   tok23 byte "OR", 0                               
   tok24 byte "SHL", 0                         
   tok25 byte "SHR", 0                         
   tok26 byte "FOR", 0                                    
   tok27 byte "TO", 0
   tok28 byte "STEP", 0                            
   tok29 byte "NEXT", 0                 
   tok30 byte "INA", 0                      
   tok31 byte "OUTA", 0                               
   tok32 byte "PAUSE", 0                                  
   tok33 byte "USING", 0                                 
   tok34 byte "ROL", 0                         
   tok35 byte "ROR", 0                         
   tok36 byte "SAR", 0                         
   tok37 byte "REV", 0                         
   tok38 byte "BYTE", 0                      
   tok39 byte "WORD", 0                      
   tok40 byte "LONG", 0                      
   tok41 byte "CNT", 0
   tok42 byte "PHSA", 0
   tok43 byte "PHSB", 0
   tok44 byte "FRQA", 0
   tok45 byte "FRQB", 0
   tok46 byte "CTRA", 0
   tok47 byte "CTRB", 0
   tok48 byte "DISPLAY", 0                             
   tok49 byte "ASC", 0   '' PRINT ASC("{char}") Get the ASCII value of a character
   tok50 byte "LET", 0
   tok51 byte "STOP", 0
   tok52 byte "END", 0
   tok53 byte "REBOOT", 0            
   tok54 byte "FILE", 0            
   tok55 byte "MEM", 0            
   tok56 byte "BRUN", 0                                                    
   tok57 byte "PWMRATE", 0                                        
   tok58 byte "COLOR", 0                                             
   tok59 byte "LOCATE",0                           
   tok60 byte "PLOT",0                              
   tok61 byte "CLEAR",0  '' CLEAR extended SRAM memory
   tok62 byte "INKEY",0              
   tok63 byte "SUSTAIN",0                                         
   tok64 byte "REDEFINE",0                                                                            
   tok65 byte "CLS",0                      
   tok66 byte "HOME",0                    
   tok67 byte "JOY",0                                       
   tok68 byte "NOTEON",0                         
   tok69 byte "NOTEOFF",0             
   tok70 byte "PWMINIT",0                                         
   tok71 byte "FILTER",0                                         
   tok72 byte "DECAY",0
   tok73 byte "PLUCK",0
   tok74 byte "SERIAL",0 '' Open Serial Communication SERIAL RX,TX,MODE,BAUD
   tok75 byte "TX",0     '' TX <serial data>
   tok76 byte "RX",0     '' RX <serial data>     {does not wait}
   tok77 byte "VER",0    '' Display Revision Information
   tok78 byte "PEEK",0   '' PEEK({location})  Return value from SRAM [0..32767]
   tok79 byte "POKE",0   '' POKE {location},{value} Poke value into SRAM [0..32767]
   tok80 byte "LINE",0   '' LINE(x0, y0, x1, y1, c)
   tok81 byte "BOX",0    '' BOX(x0, y0, x1, y1, c)
   tok82 byte "DOS",0
   tok83 byte "HOLD",0

   toks  word @tok0, @tok1, @tok2, @tok3, @tok4, @tok5, @tok6, @tok7
         word @tok8, @tok9, @tok10, @tok11, @tok12, @tok13, @tok14, @tok15
         word @tok16, @tok17, @tok18, @tok19, @tok20, @tok21, @tok22, @tok23
         word @tok24, @tok25, @tok26, @tok27, @tok28, @tok29, @tok30, @tok31
         word @tok32, @tok33, @tok34, @tok35, @tok36, @tok37, @tok38, @tok39
         word @tok40, @tok41, @tok42, @tok43, @tok44, @tok45, @tok46, @tok47
         word @tok48, @tok49, @tok50, @tok51, @tok52, @tok53, @tok54, @tok55
         word @tok56, @tok57, @tok58, @tok59, @tok60, @tok61, @tok62, @tok63
         word @tok64, @tok65, @tok66, @tok67, @tok68, @tok69, @tok70, @tok71
         word @tok72, @tok73, @tok74, @tok75, @tok76, @tok77, @tok78, @tok79
         word @tok80, @tok81, @tok82, @tok83
   tokx  word
   syn   byte "Syntax Error", 0
   ln    byte "Invalid Line Number", 0
 notopen byte "Can't open file",13,0
 notread byte "Can't create file",13,0
 badpin  byte "Invalid pin number",13,0
 
pub main | err, s, localkey
                                                                             
   init 
   backcolor(bgcolor)                   
   textcolor(txcolor)            
   out($00)
   synth.start(audior, audiol)
   key.start(keypins)                                                   
   classic.init(wiiscl,wiisda)                                             
   fsrw.start(@iocontrol)                                              
   decayrate:=16
   attackrate:=15
   sustainlevel:=64
   pulsewidthinit:=256
   pwmrate:=12
   fil:=2
   pausetime := 0
   outputs := 0
   fileopened := 0
   redefine(96,255,255,255,255,255,255,255,255) 
   long[userptr] := userptr - progsize                            
   waitcnt(clkfreq + cnt)
   if not key.present                                
     str(string("Keyboard Required.",13))
     localkey:=0
   key.clearkeys
   key.breakcode(breakkey)
   clearall
   s := 0
   curlineno := -1
                                
   ifnot \fsrw.mount(spido,spiclk,spidi,spics) < 0
      ifnot \fsrw.popen(string("desktop.tmp"),"r")
         if (err := \processload) <> feof
            showerror(err)
            newprog
         ifnot \fsrw.pclose < 0
            \fsrw.unmount
         if err == feof
            s := string("run")

   \fsrw.unmount

   sram.init( sramcs, sramclk, sramdi, sramdo )                              
   sram.sramw(32757,65)
          
   str(string(13,"        **** PROPELLER COLOR BASIC V2 ****",13,13))
   str(string("          32K RAM SYSTEM "))
   dec(progsize)
   str(string(" BYTES FREE",13))
   if sram.sramr(32757) == 65
      str(string(13,"          32K EXTENDED MEMORY BYTES FREE",13))
      sram.sramw(32757,0)
   out(freturn)
   printready
   repeat
      err := \doline(s)
      s := 0
      if err
         showerror(err)
pub memoryclear

    sram.SRAM_Fill(0,32758,0) 
     
pri showerror(err)

   if curlineno => 0
      str(string("IN LINE "))
      dec(curlineno)
      out(" ")
   if err < 0
      str(string("SD card "))
      dec(err)
      out(cr)
   else
      putlinet(err)
   nextlineloc := eop - 2

pri getline | i, c, cp,ep,counter

   i := 0
   cp := 0                          
   ep := cp                                       
   out(96)                 
   repeat
      counter++
      if counter == 9000                                              
        redefine(96,0,0,0,0,0,0,0,0)                              
      if counter == 18000                                             
        counter:=0
        redefine(96,255,255,255,255,255,255,255,255)
      c := key.key

      if c > 0
        if c == 208                                   
          erasecursor
          savereturn
          if \fsrw.popen(string("basedit.bin"),"r")
            abort string(13,"Missing Editor: basedit.bin",13,"READY.")
          fsrw.bootsdcard
        
        if c == bspkey
           if i > 0
             erasecursor
             erasecursor
             out(96)
             i--
  
        elseif c == freturn
           erasecursor
           out(c)
           tline[i] := 0
           tp := @tline
           return 
                   
        elseif i < linelen-1
           if i == 49 or i == 98 or i==147 or i == 196 or i ==245               
              c_set(xx-1, yy, 32)                                             

           out(8)
           out(c)                                                           
           out(96)   
           tline[i++] := c

PUB savereturn

          mount
          if \fsrw.popen(string("desktop.tmp"),"w")
            abort str(@notread)
          processsave
          closefile
          
pri erasecursor
     str(string(8,32,8))

pri putlinet(s) | c, ntoks

   ntoks := (@tokx - @toks) / 2
   repeat while c := byte[s++]
      if c => 128
         if (c -= 128) < ntoks
            str(@@toks[c])
            if c <> 7        
               out(" ")
         else
            out("{")
            dec(c)
            out("}")
      else
         out(c)
   out(freturn)

pri spaces | c

   repeat
      c := byte[tp]
      if c == 0 or c > " "
         return c
      tp++

pri skipspaces

   if byte[tp]
      tp++
   return spaces

pri parseliteral | r, c

   r := 0
   repeat
      c := byte[tp]
      if c < "0" or c > "9"
         return r
      r := r * 10 + c - "0"
      tp++

pri movprog(at, delta)

   if eop + delta + 2 - long[userptr] > progsize
      abort string("NO MEMORY")
   bytemove(at+delta, at, eop-at)
   eop += delta

pri fixvar(c)

   if c => "a"
      c -= 32
   return c - "A"

pri isvar(c)

   c := fixvar(c)
   return c => 0 and c < 26

pri tokenize | tok, c, at, put, state, i, j, ntoks

   ntoks := (@tokx - @toks) / 2
   at := tp
   put := tp
   state := 0
   repeat while c := byte[at]
      if c == quote
         if state == "Q"
            state := 0
         elseif state == 0
            state := "Q"
      if state == 0
         repeat i from 0 to ntoks-1
            tok := @@toks[i]
            j := 0
            repeat while byte[tok] and ((byte[tok] ^ byte[j+at]) & casebit) == 0
               j++
               tok++
            if byte[tok] == 0 and not isvar(byte[j+at])
               byte[put++] := 128 + i
               at += j
               if i == 7
                  state := "R"
               else
                  repeat while byte[at] == " "
                     at++
                  state := "F"
               quit
         if state == "F"
            state := 0
         else
            byte[put++] := byte[at++]
      else
         byte[put++] := byte[at++]
   byte[put] := 0

pri wordat(loc)

   return (byte[loc]<<8)+byte[loc+1]

pri findline(lineno) | at

   at := long[userptr]
   repeat while wordat(at) < lineno
      at += 3 + strsize(at+2)
   return at

pri insertline | lineno, fc, loc, locat, newlen, oldlen

   lineno := parseliteral
   if lineno < 0 or lineno => 65535
      abort @ln
   tokenize
   fc := spaces
   loc := findline(lineno)
   locat := wordat(loc)
   newlen := 3 + strsize(tp)
   if locat == lineno
      oldlen := 3 + strsize(loc+2)
      if fc == 0
         movprog(loc+oldlen, -oldlen)
      else
         movprog(loc+oldlen, newlen-oldlen)
   elseif fc
      movprog(loc, newlen)
   if fc
      byte[loc] := lineno >> 8
      byte[loc+1] := lineno
      bytemove(loc+2, tp, newlen-2)

pri clearvars

   longfill(@vars, 0, 26)
   pausetime := 0
   nextlineloc := long[userptr]
   sp := 0

pri newprog

   byte[long[userptr]][0] := 255
   byte[long[userptr]][1] := 255
   byte[long[userptr]][2] := 0
   eop := long[userptr] + 2
   nextlineloc := eop - 2
   sp := 0

pri clearall

   newprog
   clearvars

pri pushstack

   if sp => constant(maxstack-1)
      abort string("RECURSION ERROR")
   stack[sp++] := nextlineloc

pri getaddress(delim) | t

   if spaces <> "["
      abort @syn
   skipspaces
   result := expr
   if delim == "." and (result < 0 or result > 31)
      abort str(@badpin) 
   if delim == "." or delim == ","
      if spaces == delim
         if delim == "."                                             
            if byte[++tp] <> "."
               abort @syn
            result <<= 8
            skipspaces
            t := expr
            if t < 0 or t > 31
               abort str(@badpin)
            result |= t | $10000
         else                                                       
            if result & 1 or result < 0 or result > 31
               abort str(@badpin)
            skipspaces
            result := (result << 18) | (expr & $7ffff)
      elseif delim == ","
         result := (result & $7ffff) | fsrw#bootaddr
   if spaces <> "]"
      abort @syn
   tp++

pri factor | tok, t, i,aa,a,j

   tok := spaces
   tp++
   case tok
      "(":
         t := expr
         if spaces <> ")"
            abort @syn
         tp++
         return t
      177:
         return expr
      "a".."z","A".."Z":
         return vars[fixvar(tok)]
      158:                           
         t := getaddress(".")
         if t > $ffff
           tok := t & $ff
           t := (t >> 8) & $ff
           repeat i from t to tok
              outputs &= ! |< i
           dira[t..tok]~
           return ina[t..tok]
         else
           outputs &= ! |< t
           dira[t]~
           return ina[t]
      166:                  
         return byte[getaddress(" ")]
      167:                  
         return word[getaddress(" ")]
      168:                  
         return long[getaddress(" ")]
      181:                    
         return 
         
      182:       
         return fsrw.pgetc
      183:      
         return progsize - (eop - long[userptr] )
      169:      
         return cnt
      170:       
         return phsa
      171:       
         return phsb
      172:       
         return frqa
      173:       
         return frqb
      174:       
         return ctra
      175:       
         return ctrb
                                    
                               
      190:                                       
          return key.key
      195:     
          classic.readclassic
          Wii_Pad := classic.buttons
          if(Wii_Pad & WII_A)
              return 2048            
          if(Wii_Pad & WII_B)
              return 8192
          else
            return Wii_Pad

      139:               
         return (rv? >> 1) ** (factor << 1)
      204: 'RX
         return serial.rxtime(30)
      206: 'PEEK SRAM
         return sram.sramr(expr)
                  
         
      "-":
         return - factor
      "!":
         return ! factor
      "$", "%", quote, "0".."9":
         --tp
         return getanynumber
      other:
         abort(@syn)

pri shifts | tok, t

   t := factor
   tok := spaces
   if tok == 152      
      tp++
      return t << factor
   elseif tok == 153      
      tp++
      return t >> factor
   elseif tok == 162      
      tp++
      return t <- factor
   elseif tok == 163      
      tp++
      return t -> factor
   elseif tok == 164      
      tp++
      return t ~> factor
   elseif tok == 165      
      tp++
      return t >< factor
   else
      return t

pri bitfactor | tok, t

   t := shifts
   repeat
      tok := spaces
      if tok == "&"
         tp++
         t &= shifts
      else
         return t

pri bitterm | tok, t

   t := bitfactor
   repeat
      tok := spaces
      if tok == "|"
         tp++
         t |= bitfactor
      elseif tok == "^"
         tp++
         t ^= bitfactor
      else
         return t

pri term | tok, t

   t := bitterm
   repeat
      tok := spaces
     if tok == "*"
        tp++
        t *= bitterm
     elseif tok == "/"
        if byte[++tp] == "/"
           tp++
           t //= bitterm
        else
           t / =bitterm
     else
        return t

pri arithexpr | tok, t

   t := term
   repeat
      tok := spaces
      if tok == "+"
         tp++
         t += term
      elseif tok == "-"
         tp++
         t -= term
      else
         return t

pri compare | op, a, b, c

   a := arithexpr
   op := 0
   spaces
   repeat
      c := byte[tp]
      case c
         "<": op |= 1
              tp++
         ">": op |= 2
              tp++
         "=": op |= 4
              tp++
         other: quit
   case op
      0: return a
      1: return a < arithexpr
      2: return a > arithexpr 
      3: return a <> arithexpr
      4: return a == arithexpr
      5: return a =< arithexpr
      6: return a => arithexpr
      7: abort string("Invalid comparison")

pri logicnot | tok

   tok := spaces
   if tok == 149      
      tp++
      return not compare
   return compare

pri logicand | t, tok

   t := logicnot
   repeat
      tok := spaces
      if tok == 150      
         tp++
         t := t and logicnot
      else
         return t

pri expr | tok, t

   t := logicand
   repeat
      tok := spaces
      if tok == 151     
         tp++
         t := t or logicand
      else
         return t

pri specialexpr

   if spaces <> "="
      abort @syn
   skipspaces
   return expr

pri scanfilename(f) | c, chars

   chars := 0
   tp++                          
   repeat while (c := byte[tp++]) <> quote
      if chars++ < 31
         byte[f++] := c
   byte[f] := 0

pri scaninput(f) | c, chars

   chars := 0
   repeat while (c := byte[tp++]) <> 0
      if chars++ < 31
         byte[f++] := c
   byte[f] := 0

pri texec | ht, nt, restart, thisline, us, a,b,c,d,ffont,r,a0,tt,oldcolor

   us := clkfreq / 1_000_000
   thisline := tp - 2
   restart := 1
   repeat while restart
      restart := 0
      ht := spaces
      if ht == 0
         return
      nt := skipspaces
      if isvar(ht) and nt == "="
         tp++
         vars[fixvar(ht)] := expr
      elseif ht => 128
         case ht
            128:       
               a := expr
               if spaces <> 129
                  abort string("MISSING THEN")
               skipspaces
               if not a
                  return
               restart := 1
            130:  'INPUT                                    
               if nt == quote
                  c := byte[++tp]
                  repeat while c <> quote and c
                     out(c)
                     c := byte[++tp]
                  if c <> quote
                     abort @syn
                  if skipspaces <> ";"
                     abort @syn
                  nt := skipspaces
               if nt =="$"
                 getline
                 scaninput(@a0)
                 quit
               if not isvar(nt)
                  abort @syn
               b := 0
               invars[b++] := fixvar(nt)
               repeat while skipspaces == ","
                  nt := skipspaces
                  if not isvar(nt) or b == 26
                     abort @syn
                  invars[b++] := fixvar(nt)
               getline
               tokenize
               repeat a from 1 to b
                  vars[invars[a-1]] := expr
                  if a < b
                     if spaces == ","
                        skipspaces
            131: 'PRINT        
               a := 0
               repeat
                  nt := spaces
                  if nt == 0 or nt == ":"
                     quit
                  if nt =="$"
                      str(@a0)
                              
                      quit
                  if nt == quote
                     tp++
                     repeat
                        c := byte[tp++]
                        if c == 0 or c == quote
                           quit
                        out(c)
                        a++
                  else
                     d~
                     if (b := expr) < 0
                        -b
                        out("-")
                        a++
                     c := 1_000_000_000
                     repeat 10
                        if b => c
                           out(b / c + "0")
                           a++
                           b //= c
                           d~~
                        elseif d or c == 1
                           out("0")
                           a++
                        c /= 10
                  nt := spaces
                  if nt == ";"
                     tp++
                  elseif nt == ","
                     out(" ")
                     a++
                     repeat while a & 7
                        out(" ")
                        a++
                     tp++
                  elseif nt == 0 or nt == ":"
                     out(freturn)
                     quit
                  else
                     abort @syn
            132, 133:              
               a := expr
               if a < 0 or a => 65535
                  abort @ln
               b := findline(a)
               if wordat(b) <> a
                  abort @ln
               if ht == 133
                  pushstack
               nextlineloc := b 
            134:         
               if sp == 0
                  abort string("INVALID RETURN")
               nextlineloc := stack[--sp]
            135:      
               repeat while skipspaces
            136:      
               clearall
               mount
               if \fsrw.popen(string("desktop.tmp"),"d")
                  abort string(" ")
               closefile
               \fsrw.unmount
               printready  
            137:                          
               b := 0                                    
               c := 65535
               if spaces <> 0                                
                  b := c := expr
                  if spaces == ","
                     skipspaces
                     c := expr
               a := long[userptr]
               repeat while a+2 < eop
                  d := wordat(a)
                  if d => b and d =< c
                     dec(d)
                     out(" ")
                     putlinet(a+2)
                  a += 3 + strsize(a+2)
               printready  
            138:  'RUN
                  if (nt := spaces) == quote
                     scanFilename(@f0)
                     Mount
                     if \fsrw.popen(@f0,"r")        ' Open requested file
                        abort str(@notopen) 
                     bytemove(@tailLine,tp,strsize(tp)+1)
                     newprog
                     processLoad
                     CloseFile 
                     \fsrw.unmount
                     
                  
                  repeat c from 0 to 15
                      if outputs & |< c
                         dira[c]~
                         outa[c]~
                  outputs := 0     
                  clearvars
        
            140:                         
               if spaces <> quote
                  abort @syn
               scanfilename(@f0)
               if spaces <> ","
                  abort @syn
               case skipspaces
                  "A", "a": d := "a"
                  "W", "w": d := "w"
                  "R", "r": d := "r"
                  other: abort string("Invalid open file mode")
               tp++
               mount
               if \fsrw.popen(@f0,d)
                  abort str(@notopen) 
               fileopened := true
            141:                        
               if not isvar(nt)
                  abort @syn
               d := 0
               invars[d++] := fixvar(nt)
               repeat while skipspaces == ","
                  nt := skipspaces
                  if not isvar(nt) or d == 26
                     abort @syn
                  invars[d++] := fixvar(nt)
               a := 0
               repeat
                  c := fsrw.pgetc
                  if c < 0
                     abort str(@notread) 
                  elseif c == freturn or c == feof
                     tline[a] := 0
                     tp := @tline
                     quit
                  elseif c == flinefeed
                     next
                  elseif a < linelen-1
                     tline[a++] := c
               tokenize
               repeat a from 1 to d
                  vars[invars[a-1]] := expr
                  if a < d
                     if spaces == ","
                        skipspaces
            142:            
               d := 0                
               repeat
                  nt := spaces
                  if nt == 0 or nt == ":"
                     quit
                  if nt == quote
                     tp++
                     repeat
                        c := byte[tp++]
                        if c == 0 or c == quote
                           quit
                        fsrw.pputc(c)
                        d++
                  else
                     a := expr
                     if a < 0
                        -a
                        fsrw.pputc("-")
                     b := 1_000_000_000
                     c := false
                     repeat 10
                        if a => b
                           fsrw.pputc(a / b + "0")
                           a //= b
                           c := true
                        elseif c or b == 1
                           fsrw.pputc("0")
                        b /= 10
                  nt := spaces
                  if nt == ";"
                     tp++
                  elseif nt == ","
                     fsrw.pputc(" ")
                     d++
                     repeat while d & 7
                        fsrw.pputc(" ")
                        d++
                     tp++
                  elseif nt == 0 or nt == ":"
                     fsrw.pputc(freturn)
                     fsrw.pputc(flinefeed)
                     quit
                  else
                     abort @syn
            143:        
               fileopened := false
               closefile 
               \fsrw.unmount
            144:                    
               if spaces <> quote
                  abort @syn
               scanfilename(@f0)
               mount
               if \fsrw.popen(@f0,"d")
                  abort string("Can't delete file")
               if \fsrw.pclose < 0
                  abort string("Error deleting file")
               \fsrw.unmount
            145:                
                  attackrate:=expr
            146:  'DIR     
             
               mount
               fsrw.opendir
               
               b := 0
               d := false
               repeat while fsrw.nextfile(@f0) == 0  
                  d := true
                  if b == 39
                     out(cr)
                     b := 0

                  tt:=(StrRight(@f0,3))
                  oldcolor:=crayon
                  if textcomp(tt,string("BAS"),3) == true
                      textcolor(BASfiles) 
                  if textcomp(tt,string("BIN"),3) == true
                      textcolor(BINfiles)
                  if textcomp(tt,string("TXT"),3) == true
                      textcolor(TXTfiles)          
                  str(@f0)
                      textcolor(oldcolor)
                  repeat 13 - strsize(@f0)
                     out(" ")
                  b := b + 13
               if d
                  out(cr)
               \fsrw.unmount
              
               printready  
            147:                            
               if (nt := spaces) == quote
                  scanfilename(@f0)
                  mount
                  if \fsrw.popen(@f0,"w")
                     abort str(@notopen)
                  processsave
                  closefile 
                  \fsrw.unmount
                  printready  
            148:                           
               if (nt := spaces) == quote
                  scanfilename(@f0)
                  mount
                  if \fsrw.popen(@f0,"r")                             
                     abort str(@notopen) 
                  bytemove(@tailline,tp,strsize(tp)+1)
                  newprog
                  processload
                  closefile 
                  \fsrw.unmount
                  printready  
            
            154:                                             
               ht := spaces
               if ht == 0
                  abort @syn
               nt := skipspaces
               if not isvar(ht) or nt <> "="
                  abort @syn
               a := fixvar(ht)
               skipspaces
               vars[a] := expr
               if spaces <> 155                                  
                  abort @syn
               skipspaces
               forlimit[a] := expr
               if spaces == 156                                  
                  skipspaces
                  forstep[a] := expr
               else
                  forstep[a] := 1                                   
               if spaces
                  abort @syn
               forloop[a] := nextlineloc                               
               if forstep[a] < 0                                     
                  b := vars[a] => forlimit[a]
               else                                                         
                  b := vars[a] =< forlimit[a]
               if not b                                                     
                  repeat while nextlineloc < eop-2
                     curlineno := wordat(nextlineloc)
                     tp := nextlineloc + 2
                     nextlineloc := tp + strsize(tp) + 1
                     if spaces == 157                        
                        nt := skipspaces                                
                        if not isvar(nt)
                           abort @syn
                        if fixvar(nt) == a                                 
                           quit                                      
            157:             
               nt := spaces
               if not isvar(nt)
                  abort @syn
               a := fixvar(nt)
               vars[a] += forstep[a]                                         
               if forstep[a] < 0                                              
                  b := vars[a] => forlimit[a]
               else                                                
                  b := vars[a] =< forlimit[a]
               if b                                                         
                  nextlineloc := forloop[a]                            
               tp++
            159:                                     
               a := getaddress(".")
               if a > $ffff
                  b := a & $ff
                  a := (a >> 8) & $ff
                  outa[a..b] := specialexpr
                  dira[a..b]~~
                  repeat c from a to b
                     outputs |= |< c
               else
                  outa[a] := specialexpr
                  dira[a]~~
                  outputs |= |< a
            160:                         
               if pausetime == 0                                                  
                  spaces                                                       
                  pausetime := expr * 1000
                  if spaces == ","                                             
                     skipspaces
                     pausetime += expr                                  
                  pausetime #>= 50
               if pausetime < 10_050                                                     
                  waitcnt(pausetime * us + cnt)                                     
                  pausetime := 0                                               
               else                             
                  a := pausetime <# 10_000     
                  waitcnt(a * us + cnt)                                             
                  nextlineloc := thisline                                            
                  pausetime -= 10_000
            166:                           
               a := getaddress(" ")
               byte[a] := specialexpr
            167:                           
               a := getaddress(" ")
               word[a] := specialexpr
            168:                           
               a := getaddress(" ")
               long[a] := specialexpr
            170:         
               phsa := specialexpr
            171:         
               phsb := specialexpr
            172:         
               frqa := specialexpr
            173:         
               frqb := specialexpr
            174:         
               ctra := specialexpr
            175:         
               ctrb := specialexpr
            176:                           
               spaces
               out(expr)
               repeat while spaces == ","
                  skipspaces
                  out(expr)
            178:                     
               nt := spaces
               if not isvar(nt)
                  abort @syn
               tp++
               vars[fixvar(nt)] := specialexpr
            179:       
               nextlineloc := eop-2
               return
            180:      
               nextlineloc := eop-2
               return
            181:
                out($00)  
                memoryclear           
                reboot
            182:                
               if fsrw.pputc(specialexpr) < 0
                  abort str(@notread) 
            184: 'BRUN
                if spaces == quote
               
                  scanfilename(@f0)
                  scanfilename(@f1)
                  mount
                  fsrw.popen(string("COMMAND.TXT"),"d")
                  closefile
                  if f1[0]<>105 and f1[1]<>110 'corrects a parsing bug

                      if \fsrw.popen(string("COMMAND.TXT"),"w")
                          abort str(@notopen)      
                       d:=0
                     { repeat
                           c:=byte[@f0][d]
                           if c == 46
                              quit
                           fsrw.pputc(c)
                           d++          
                      fsrw.pputc(32)
                      d:=0      }
                      
                      repeat
                            c := byte[@f1][d]
                            if c == 0 
                               quit
                            a := (@tokx - @toks) / 2      
                            if c => 128
                              if (c -= 128) < a
                                  fsrw.str(@@toks[c])
                                 c:=0
                            else  
                            if c > 96 and c < 123
                                c:=c-32                                   
                            fsrw.out(c)

                            d++
                     closefile

                  if \fsrw.popen(@f0,"r")
                     abort str(@notopen)
                  fsrw.bootsdcard    
            185:
                  pwmrate:=expr
                     
            186: 'COLOR
               fetchcommandline(1)
               backcolor(rdc[1]*4)
               textcolor(rdc[0]*4)
               
            187:  'LOCATE                    
               c := expr                                              
               if spaces <> ","                           
                   abort @syn
               skipspaces
               d := expr
               if d > 36
                  d:=36 
               if c > 49
                  c:=49 
               xx := c
               yy := d
               
            188:  'PLOT
                fetchcommandline(2)
                plot(rdc[0],rdc[1],rdc[2]*4)
                
            189: 'CLEAR SRAM
                memoryclear
                               
            191: 'SUSTAIN
                sustainlevel:=expr
                
            192: 'REDEFINE
               fetchcommandline(8)
               if rdc[0] > 127
                  rdc[0]:=127
               redefine(rdc[0],rdc[1],rdc[2],rdc[3],rdc[4],rdc[5],rdc[6],rdc[7],rdc[8])

           193:                   
                 out($00) 
           194:                   
                 xx := yy := 0 
           196:        
                 synth.noteon(expr, attackrate, sustainlevel, pulsewidthinit, pwmrate, fil)
           197:         
                 synth.noteoff(decayrate)
           198:         
                 pulsewidthinit:=expr
           199:        
                 a:=expr
                 if a > 12
                    a:= 12
                 fil:=a
           200:       
                 decayrate:=expr
           201:
                 synth.pluck(expr, decayrate, sustainlevel, pulsewidthinit, pwmrate, fil)

           202: 'OPENSER
                fetchcommandline(3)
                serial.start(rdc[0],rdc[1],rdc[2],rdc[3])

           203: 'TX
               serial.tx(expr)
               
           205: 'VERSION
               str(string(13,"Propeller Color Basic ",versiona,46,versionb,versionc,13))
           
           207: 'POKE SRAM
                fetchcommandline(1)
                sram.sramw(rdc[0],rdc[1])

           208: ''line(x0, y0, x1, y1, c)                                                        
                fetchcommandline(4)
                line(rdc[0],rdc[1],rdc[2],rdc[3],rdc[4])

           209: ' box(x0, y0, x1, y1, c)
               fetchcommandline(4)
               box(rdc[0],rdc[1],rdc[2],rdc[3],rdc[4])


           210: 'Boot DOS
               mount
               if \fsrw.popen(string("dos.bin"),"r")
                     abort str(@notopen) 
               fsrw.bootsdcard

           211: 'HOLD
                savereturn  
      else                                   
         abort(@syn)
      if spaces == ":"
         restart := 1
         tp++

PUB fetchcommandline (numcmds) | xxx

 repeat xxx from 0 to numcmds
    rdc[xxx]:=expr
    skipspaces
 return

pri doline(s) | c                                                            

   curlineno := -1
   if key.breaktest                                             
      key.clearkeys                                                 
      key.breakcode(breakkey)                                 
      nextlineloc := eop-2                          
      printready  
   if nextlineloc < eop-2
      curlineno := wordat(nextlineloc)
      tp := nextlineloc + 2
      nextlineloc := tp + strsize(tp) + 1
      texec
   else
      if fileopened
         fileopened := false
         if fsrw.pclose < 0
            str(string("Error closing open file",freturn))
         \fsrw.unmount
      pausetime := 0
  {    repeat c from 0 to 15
         if outputs & |< c
            dira[c]~
            outa[c]~
      outputs := 0        }
      if s
         bytemove(tp:=@tline,s,strsize(s)+1)
      else
                                   
         getline
      c := spaces
      if "0" =< c and c =< "9"
         insertline
         nextlineloc := eop - 2
      else
         tokenize
         if spaces
            texec

pri processload : c | a

   repeat
      a := 0
      repeat
         c := fsrw.pgetc
         if c == freturn or c == feof
            tline[a] := 0
            tp := @tline
            quit
         elseif c == flinefeed
            next
         elseif c < 0
            quit
         elseif a < linelen-1
            tline[a++] := c
      if c == feof and tline[0] == 0
         quit
      if c < 0
         abort str(@notopen)
      tp := @tline
      a := spaces
      if "0" =< a and a =< "9"
         insertline
         nextlineloc := eop - 2
      else
         if a <> 0
            abort string("Missing line number in file")

pri processsave | a, c, d, ntoks

   ntoks := (@tokx - @toks) / 2
   a := long[userptr]
   repeat while a+2 < eop
      d := wordat(a)
      fsrw.dec(d)
      fsrw.out(" ")
      d := a + 2
      repeat while c := byte[d++]
         if c => 128
            if (c -= 128) < ntoks
               fsrw.str(@@toks[c])
               if c <> 7        
                  fsrw.out(" ")
            else
               fsrw.out("{")
               fsrw.dec(c)
               fsrw.out("}")
         else
            fsrw.out(c)
      fsrw.out(freturn)
      fsrw.out(flinefeed)
      a += 3 + strsize(a+2)

pri getanynumber | c, t

   case c := byte[tp]
      quote:      
         if result := byte[++tp]
            if byte[++tp] == quote
              tp++
            else
               abort string("missing closing quote")
         else
            abort string("end of line in string")
      "$":
   
        c := byte[++tp]
         if (t := hexdigit(c)) < 0
            abort string("invalid hex character")
         result := t
         c := byte[++tp]
         repeat until (t := hexdigit(c)) < 0
            result := result << 4 | t
            c := byte[++tp]    
      "%":
         c := byte[++tp]
         if not (c == "0" or c == "1")
            abort string("invalid binary character")
         result := c - "0"
         c := byte[++tp]
         repeat while c == "0" or c == "1"
            result := result << 1 | (c - "0")
            c := byte[++tp]
      "0".."9":
         result := c - "0"
         c := byte[++tp]
         repeat while c => "0" and c =< "9"
            result := result * 10 + c - "0"
            c := byte[++tp]
      other:
        abort string("invalid literal value")

pri hexdigit(c)

                                                                             
   if c => "0" and c =< "9"
      return c - "0"
   if c => "A" and c =< "F"
      return c - "A" + 10
   if c => "a" and c =< "f"
      return c - "a" + 10
   return -1

pub mount

       if \fsrw.mount(spido,spiclk,spidi,spics) < 0
          abort string("Can't mount SD card")

pub closefile

    if \fsrw.pclose < 0
       abort string("Error closing file")

pub printready

    putlinet(string("READY.")) 

PUB StrRight(strr,len) | i,l,z,j

  l:=strSize(strr)
  z:=0
  repeat i from l-len to l
    strbuff[z] := byte[strr][i]
    z++
  return @strbuff

PRI textComp(str1,str2,len)
   repeat len
      if byte[str1++] <> byte[str2++]
         return false
   return true
   
pub init

  link    := @scrn.byte[bcnt_raw - columns]                                        
  link[1] := font#height << 24 | font.addr                               
  link[2] := cext := @plte                                             
  redefine_plot
  cognew(@scrn[scrn.word[2]], @link   )                                                   
  repeat while link                                                                             
  wordfill(@scrn   ,   $2020, constant(bcnt_raw / 2))                 
  longfill(@plte   , dcolour, constant(bcnt_raw / 2))                   

{pub putc(c)

  if cext                                                                         
    word[cext][yy * columns + xx] := colour                              
 
  scrn.byte[bcnt_raw - yy * columns - ++xx] := c                                              
  if xx == columns                                         
    xx := newline     }                                          

pub putc(c)

  if cext                                                                         
    word[cext][yy * columns + xx] := colour                              
 
  scrn.byte[bcnt_raw - yy * columns - ++xx] := c                                              
  if xx > columns
    xx := newline 

pri newline

  if ++yy == rows
     
    if page                                                           
      
      yy := 0
      return
    yy--
                                                                          
                                                                           
                                                                           
 
    if cext
      wordmove(cext, @word[cext][columns], constant(bcnt_raw - columns))
      wordfill(@word[cext][constant(bcnt - columns)], colour, columns)
      
    wordmove(@scrn.byte[columns], @scrn   , constant((bcnt_raw - columns) / 2))
    if rows_raw == rows
      wordfill(@scrn   , $2020, constant(columns / 2))

pub str(addr)

  repeat strsize(addr)
    out(byte[addr++])

pub out(c) : succ

                                 
  case flag.byte   
    $00: case c                                             
           $00..$01,ff:                            
             if c <> $01                           
               if cext
                 wordfill(cext, colour, bcnt_raw)
               wordfill(@scrn   , $2020, constant(bcnt_raw / 2))
             xx := yy := 0                           
           $08: xx := (xx - 1) #> 0                  
           tab: repeat 8 - (xx & 7)                    
                  putc(" ")                         
           $0a..$0b: flag := c << 8 | "="                                                
           $0d: xx := newline                                   
           esc: flag := c                           
           other: putc(c)                            
    esc: case c
           "s", "S": page := c & $20                                                          
           "=":      succ := constant($0200 | "=")                  
           "c":      succ := constant($0200 | "c")                                    
         flag := succ~           
    "=": case flag.byte[1]--
           2..10: flag &= tr(c, @xx, columns, flag >> 11)
           other: flag := tr(c, @yy, rows, true)
    "c": case flag.byte[1]--
           2:         sc(c, 1)
           1: flag := sc(c, 0)

pri tr(c, addr, limit, response)

  if c.byte    < 255
    byte[addr] := c.byte    // limit
  return not response

pri sc(c, idx)

  colour.byte[idx] := c & hv_mask | hv_idle


pub dec(value) | s[4], p

  s    := value < 0                                                    
  p := @p                                                                          
  byte[--p] := 0                                                          
  
  repeat
    byte[--p] := ||(value // 10) + "0"                     
    value /= 10                                            
  while value                                                                          
  if s                                                              
    byte[--p] := "-"                                                  
  repeat strsize(p)
    putc(byte[p++])                                                  

PUB line(x0, y0, x1, y1, c) | dX, dY, x, y, err, stp
  result := ((||(y1 - y0)) > (||(x1 - x0)))
  if(result)
    swap(@x0, @y0)
    swap(@x1, @y1)
  if(x0 > x1)
    swap(@x0, @x1)
    swap(@y0, @y1)
  dX := (x1 - x0)
  dY := (||(y1 - y0))
  err := (dX >> 1)
  stp := ((y0 => y1) | 1)
  y := y0
  repeat x from x0 to x1
    if(result)
      plot(y, x, c*4)
    else
      plot(x, y, c*4)
    err -= dY
    if(err < 0)
      y += stp
      err += dX

PUB box(x0, y0, x1, y1, c) | i
  repeat i from y0 to y1-1
    line(x0, i, x1, i, c) 

PRI swap(x, y)
  result  := long[x]
  long[x] := long[y]
  long[y] := result
    
pub textcolor(value)

   colour.byte[1] := value & hv_mask | hv_idle
   crayon:=value
   
pub backcolor(value)

   colour.byte[0] := value & hv_mask | hv_idle

pub redefine(c,c0,c1,c2,c3,c4,c5,c6,c7) | base

                                               
  byte[base := font.addr + c.byte   ] := c0
  byte[base += 128] := c1
  byte[base += 128] := c2
  byte[base += 128] := c3
  byte[base += 128] := c4
  byte[base += 128] := c5
  byte[base += 128] := c6
  byte[base += 128] := c7

pri redefine_plot | i, ptr

  ptr := font.addr 
  repeat i from 0 to constant(font#height/2 -1)
    bytemove(ptr + (i << 7)                                  , @sg1, 16)
    bytemove(ptr + (i << 7) + constant(font#height / 2 * 128), @sg2, 16)

dat

sg1     byte    $00, $0f, $f0, $ff, $00, $0f, $f0, $ff, $00, $0f, $f0, $ff, $00, $0f, $f0, $ff
sg2     byte    $00, $00, $00, $00, $0f, $0f, $0f, $0f, $f0, $f0, $f0, $f0, $ff, $ff, $ff, $ff

pub plot(x, y, c) | pv, nv
  if x > 98
     x:=99
  if x < 1
     x:=0
  if y > 73
     y:=74
  if y < 1
     y:=0

  nv := |< (((y & 1) << 1) | (x & 1))   
  x >>= 1
  y >>= 1
  pv := c_get(x, y) & $0f
  if c == -1
    nv := pv & !nv
  else
    nv := pv |  nv
  c_set(x, y, nv)                        
                    
  plte.byte[(y * columns + x) << 1 + 1] := c & hv_mask | hv_idle

pri c_set(x, y, c)

  scrn.byte[bcnt_raw - (y * columns) - ++x] := c

pri c_get(x, y) : c

  c := scrn.byte[bcnt_raw - (y * columns) - ++x]

dat

scrn    long
        file    "waitvid.50xH.driver.2048.cog"
scrn_e  long    -1[bcnt_raw/4 - (@scrn_e - @scrn)/4]


dat


                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
