CON
  SAMPLE_RATE = 500_000.0  
  nf = 0.9438743967    '
  MSN = 2_00_000_000.0 * (67500.0/82000.0)
  f12 = MSN,      f11 = f12 * nf, f10 = f11 * nf, f09 = f10 * nf, f08 = f09 * nf, f07 = f08 * nf
  f06 = f07 * nf, f05 = f06 * nf, f04 = f05 * nf, f03 = f04 * nf, f02 = f03 * nf, f01 = f02 * nf
    

var

                
  byte cog
  long freqdest_, volumedest_, modulation_, filter_      

pub start(right, left) 

  stop
  tempvalue1 := $18000000 | left
  tempvalue2 := $18000000 | right
  tempvalue3 := ((1<<right) | (1<<left))&!1
  samplerate := clkfreq/trunc(sample_rate)
  cog := cognew(@tinysynth, @freqdest_) + 1

pub stop

  if cog
    cogstop(cog~ -1)
    cog := 0

pub noteon(midinote, attackrate, sustainlevel, pulsewidthinit, pwmrate, fil) 

  freqdest_   := notetofreq(midinote) 
  filter_     := fil 
  modulation_ := pulsewidthinit
  volumedest_ := (sustainlevel<<24) | attackrate
  
  if pwmrate > 0
    modulation_ := pwmrate<<9          

pub pluck(midiNote, decayRate, sustainLevel, pulseWidthInit, pwmRate, fil)
  volumeDest_ := (sustainLevel<<24) 
  noteOn(midiNote, 0, sustainLevel, pulseWidthInit, pwmRate, fil)
  noteOff(decayRate)
  
pub noteoff(decayrate)

  volumedest_ := decayrate

pri notetofreq(midinote) | octave, note

  octave  := 9-(midinote/12)
  note := (midinote//12)
  return (ftable[note] >> octave)&!31

dat

ftable        long trunc(f01)
              long trunc(f02)
              long trunc(f03)
              long trunc(f04)
              long trunc(f05)
              long trunc(f06)
              long trunc(f07)
              long trunc(f08)
              long trunc(f09)
              long trunc(f10)
              long trunc(f11)
              long trunc(f12)

dat

          org 0
tinysynth     mov       ctra, tempvalue1                       
out           mov       ctrb, tempvalue2                       
waitcounter   mov       dira, tempvalue3                                  
              mov       waitcounter, cnt                     
              add       waitcounter, samplerate   
                                                                                                                                                                                   
mainloop      cmp       :par, stopvalue                  wz
        if_z  movd      :par, #freqdest
        if_z  mov       regcounter, par                      
:par          rdlong    freqdest, regcounter                                               
              add       :par, val512                         
              add       regcounter, #4 
                                                                                                                                                                                   
              mov       tempvalue1, freq
              sub       tempvalue1, freqdest
              sar       tempvalue1, freqdest
              sub       freq, tempvalue1
              mov       tempvalue1, volume
              sub       tempvalue1, volumedest
              sar       tempvalue1, volumedest
              sub       volume, tempvalue1 
              test      mod, #511                        wz   
        if_nz movi      modulation, mod                                          
        if_z  add       modulation, mod                      
              add       phaseaccumulator, freq           wc
              abs       tempvalue2, modulation
              cmp       phaseaccumulator, tempvalue2     wc    
              mov       tempvalue1, sqrout
              sumc      tempvalue1, volume
              sar       tempvalue1, filt
              sub       sqrout, tempvalue1 
              add       out, sqrout
                                                                                                                                                                                   
              waitcnt   waitcounter, samplerate                
              mov       frqa, out                            
              mov       frqb, out                                                  
              movi      out, #256                              
              jmp       #mainloop
                                                                                                                                                                                   
stopvalue               rdlong freqdest + 4, regcounter      
samplerate              long 0                                  
tempvalue1              long 1                                
tempvalue2              long 1                                 
tempvalue3              long 1                                
val512                  long 1 << 9
regcounter              res  1
freqdest                res  1  
volumedest              res  1
mod                     res  1
filt                    res  1
freq                    res  1   
volume                  res  1
modulation              res  1
phaseaccumulator        res  1
sqrout                  res  1